import es, playerlib, gamethread, popuplib, cmdlib, popuplib, weaponlib, usermsg, effectlib, vecmath

import os, cPickle


info = es.AddonInfo()
info.name           = "Last Request"
info.version        = "1.5.13"
info.author         = "DanielB" 
info.url            = "http://www.customsource.info" 
info.description    = "Last Request for Fire" 


canLR = True
lastRequest = False
mustDie = []

games = ['Gun Toss', 'Race', 'Shot for Shot', 'Knife Fight', 'Water Bottle Baseball',
'BasketBall', 'Chicken Fight', 'Spray Contest', 'Other']

class lr:
    def __init__(self, t, ct):
        self.t = t
        self.ct = ct
        self.beacon = False
        
        self.active = True
        
        
        self.gunTrace = False
        
        self.shotct = 0
        self.shott  = 0
        self.shothud = False
        self.shothudtext = 'Enemy has fired %s Shots!'
        
    def startTrace(self):
        if self.active:
            self.gunTrace = gunTracer(self.t, self.ct)
        
    def setHealth(self, t=True, ct=True, amt=100):
        if t:
            playerlib.getPlayer(self.t).health = amt
        if ct:
            playerlib.getPlayer(self.ct).health = amt
            
    def giveBeacon(self):
        self.beacon = True
        self.setColours()
        self.beaconTick()
        
    def starthud(self):
        es.doblock('corelib/noisy_on')
        self.shothud = True
        self.shotTick()
        
    def shotTick(self):
        if self.shothud:
            usermsg.hudhint(self.t, self.shothudtext%self.shotct)
            usermsg.hudhint(self.ct, self.shothudtext%self.shott)
            others = filter(lambda x: not x in (self.t, self.ct), es.getUseridList())
            usermsg.hudhint(others, '[T] Shot %s  -----   [CT] Shot %s'%(self.shott, self.shotct))
                    
            gamethread.delayedname(1, 'lr_shotcount', self.shotTick)
            
    def stopshothud(self):
        if self.shothud:
            es.doblock('corelib/noisy_off')
        self.shothud = False
        gamethread.cancelDelayed('lr_shotcount')
        
    def beaconTick(self):
        if self.beacon:
            giveBeacon(self.t, 255, 0, 0)
            giveBeacon(self.ct, 0, 0, 255)
            gamethread.delayedname(1, 'lr_beacon', self.beaconTick)
            
    def stopBeacon(self):
        self.beacon = False
        gamethread.cancelDelayed('lr_beacon')
        
    def _start(self):
        self.setHealth()
        self.giveBeacon()
        
    def _end(self):
        if self.beacon:
            self.stopBeacon()
        if self.shothud:
            self.stopshothud()
        if self.gunTrace:
            self.gunTrace.end()
        self.setColours(plain=True)
        self.active = False
            
            
    def setColours(self, plain=False, t=True, ct=True):
        
        if plain:
            cr, cg, cb = 255, 255, 255
            tr, tg, tb = 255, 255, 255
        else:
            cr, cg, cb = 0, 0, 255
            tr, tg, tb = 255, 0, 0
            
        if t and es.exists('userid', self.t):
            playerlib.getPlayer(self.t).setColor(tr, tg, tb)
        if ct and es.exists('userid', self.ct):
            playerlib.getPlayer(self.ct).setColor(cr, cg, cb)
            
class gunTracer:
    def __init__(self, t, ct):
        self.t = t
        self.ct = ct
        
        self.getIndexs()
        
        self.tstart = False
        self.ctstart = False
        self.tpos = (0, 0, 0)
        self.ctpos = (0, 0, 0)
        
        self.tdone = False
        self.ctdone = False
        
        self.tdist = None
        self.ctdist = None
        
        self.posted = False
        self.hud()
        self.tick()
        
    def end(self):
        gamethread.cancelDelayed('lr_guntoss')
        gamethread.cancelDelayed('lr_guntosshud')
        
        if not self.posted:
            self.submitScore()
        
    def submitScore(self):
        tr, ctr = False, False
        if not self.tdist is None:
            tr  = gtSubmit(es.getplayersteamid(self.t), self.tdist, es.getplayername(self.t))
        if not self.ctdist is None:
            ctr = gtSubmit(es.getplayersteamid(self.ct), self.ctdist, es.getplayername(self.ct))
        if tr or ctr:
            gtUpdatePop()
            gtSave()
    
    def hud(self):
        if not self.tdist is None:
            tdist = '%.2f'%self.tdist
        else:
            tdist = 'Yet to throw!'
        if not self.ctdist is None:
            ctdist = '%.2f'%self.ctdist
        else:
            ctdist = 'Yet to throw!'
        usermsg.hudhint('#all', 'Deagle Toss\nT Distance: %s\nCT Distance: %s\n'%(tdist, ctdist))
        gamethread.delayedname(1, 'lr_guntosshud', self.hud)
        
    def tick(self): #tracing
        
        if (not self.ctdone) and self.ctindex:
            if not self.ctstart:
                if es.getindexprop(self.ctindex, 'CBaseEntity.m_hOwnerEntity') == -1:
                    x, y, z = es.getplayerlocation(self.ct)
                    self.ctstart = (x, y, z+64)
                    self.ctpos = tuple(self.ctstart)
            else:
                if es.getindexprop(self.ctindex, 'CBaseEntity.m_hOwnerEntity') == -1:
                    newloc = map(lambda x: float(x), es.getindexprop(self.ctindex, 'CBaseEntity.m_vecOrigin').split(','))
                    if newloc == self.ctpos:
                        self.ctdone = True
                        self.ctdist = vecmath.distance(self.ctpos, self.ctstart)
                        x, y, z = self.ctpos
                        effectlib.drawLine(self.ctpos, (x, y, z+50), seconds=0.1, red=0, green=0, blue=255)
                    else:
                        effectlib.drawLine(newloc, self.ctpos, seconds=10, red=0, green=0, blue=255)
                        self.ctpos = newloc
                else:
                    self.ctdone = True
                    self.ctdist = 0
                    msg('%s dropped his gun!'%es.getplayername(self.ct))
        else:
           x, y, z = self.ctpos
           effectlib.drawLine(self.ctpos, (x, y, z+50), seconds=0.1, red=0, green=0, blue=255)
        
        if (not self.tdone) and self.tindex:
            if not self.tstart:
                if es.getindexprop(self.tindex, 'CBaseEntity.m_hOwnerEntity') == -1:
                    x, y, z = es.getplayerlocation(self.t)
                    self.tstart = (x, y, z+64)
                    self.tpos = tuple(self.tstart)
            else:
                if es.getindexprop(self.tindex, 'CBaseEntity.m_hOwnerEntity') == -1:
                    newloc = map(lambda x: float(x), es.getindexprop(self.tindex, 'CBaseEntity.m_vecOrigin').split(','))
                    if newloc == self.tpos:
                        self.tdone = True
                        self.tdist = vecmath.distance(self.tpos, self.tstart)
                        x, y, z = self.tpos
                        effectlib.drawLine(self.tpos, (x, y, z+50), seconds=0.1, red=255, green=0, blue=0)
                    else:
                        effectlib.drawLine(newloc, self.tpos, seconds=10, red=255, green=0, blue=0)
                        self.tpos = newloc
                else:
                    self.tdone = True
                    self.tdist = 0
                    msg('%s dropped his gun!'%es.getplayername(self.t))
        else:
           x, y, z = self.tpos
           effectlib.drawLine(self.tpos, (x, y, z+50), seconds=0.1, red=255, green=0, blue=0)
        
        if not self.posted:
            if self.tdone and self.ctdone:
                self.posted = True
                if self.tdist > self.ctdist:
                    msg('%s has won the gun toss!'%es.getplayername(self.t))
                elif self.ctdist > self.tdist:
                    msg('%s has won the gun toss!'%es.getplayername(self.ct))
                else:
                    msg('Its a draw!')
                    
                self.submitScore()
                
        
        gamethread.delayedname(0.1, 'lr_guntoss', self.tick)
        
    
    def getIndexs(self):
        thandle = str(es.getplayerhandle(self.t))
        cthandle = str(es.getplayerhandle(self.ct))
        
        self.tindex = 0
        self.ctindex = 0
        
        for index in es.createentitylist('weapon_deagle'):
            handle = str(es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity'))
            if handle == thandle:
                self.tindex = index
            if handle == cthandle:
                self.ctindex = index
        
        
    def recieveIndex(self, userid, index):
        self.ctindex = 0
        self.tindex = 0
        if userid == self.ct:
            self.ctindex = index
        elif userid == self.t:
            self.tindex = index
            
def weapon_fire(ev):
    if lastRequest:
        if ev['userid'] == str(lastRequest.ct):
            lastRequest.shotct += 1
            lastRequest.shott = 0
        if ev['userid'] == str(lastRequest.t):
            lastRequest.shott += 1
            lastRequest.shotct = 0
            
            
def load():
    cmdlib.registerSayCommand('!lr', cmd_lr, 'Last Request')
    cmdlib.registerSayCommand('!guntoss', cmd_gt, 'Gun Toss Ranks')
    gtLoad()
    msg('Loaded v%s'%info.version)
    
def unload():
    cmdlib.unregisterSayCommand('!lr')
    cmdlib.unregisterSayCommand('!guntoss')
    lrMenu.delete()
    if lastRequest: lastRequest._end()
    
    msg('unloaded')

def livingCT(game, pname='lr_livingCT', callback=None):
    if popuplib.exists(pname): popuplib.delete(pname)
    p = popuplib.easymenu(pname, None, callback)
    p.settitle('Select a CT')
    for userid in playerlib.getUseridList('#alive,#ct'):
        p.addoption((userid, game), es.getplayername(userid))
    return p
    
def weaponList(ct, game, pname='lr_weaponselect', callback=None, weaponfilter='#all'):
    if popuplib.exists(pname): popuplib.delete(pname)
    p = popuplib.easymenu(pname, None, callback)
    p.settitle('Select a Weapon')
    
    weps = weaponlib.getWeaponNameList(weaponfilter)
    for weapon in weps:
        if not weapon in ('weapon_knife', 'weapon_hegrenade', 'weapon_smokegrenade', 'weapon_flashbang'):
            p.addoption((ct, game, weapon), weapon.replace('weapon_', ''))
        
    return p
    
            
def giveBeacon(userid, r, g, b):
    x, y, z = es.getplayerlocation(userid)
    es.server.queuecmd('est_effect 10 #a 0 "sprites/lgtning.vmt" %s %s %s 20 300 0.2 20 10 0 %s %s %s 255 30'%(x, y, z, r, g, b))
    es.server.queuecmd('est_effect 10 #a 0.1 "sprites/lgtning.vmt" %s %s %s 20 300 0.3 15 10 0 %s %s %s 255 30'%(x, y, z, r, g, b))
    es.emitsound('player', userid, 'buttons/blip2.wav', 0.8, 0.6)

def player_death(ev):
    global canLR, lastRequest
    
    if lastRequest:
        lastRequest._end()
        lastRequest = False
        msg('Someone\'s died! The game has ended!')
            
    allTs = filter(lambda x: es.getplayerteam(x) == 2, es.getUseridList())
    aliveTs = playerlib.getUseridList('#t,#alive')
            
    if len(aliveTs) == 1 and len(allTs) > 1:
        canLR = True
        
def player_hurt(ev):
    if (not lastRequest) and ev['es_userteam'] == '3' and ev['es_attackerteam'] == '2':
        #es.msg('#multi', '#green[Rebel]#lightgreen %s has attacked %s'%(ev['es_attackername'], ev['es_username']))
        player = playerlib.getPlayer(ev['attacker'])
        index = player.attributes['index']
        usermsg.saytext2('#all', index, '\x04[Rebel]\x03 %s\x01 has attacked\x04 %s'%(ev['es_attackername'], ev['es_username']))
        
def round_start(ev):
    global canLR, lastRequest, mustDie
    canLR = False
    if lastRequest:
        lastRequest._end()
        
    lastRequest = False
    mustDie = []
    
def tell(userid, text):
    es.tell(userid, '#multi', '#green[LR]#lightgreen '+text)
def msg(text):
    es.msg('#multi', '#green[LR]#lightgreen '+text)
    
def cmd_lr(userid, args):
    if canLR and es.getplayerteam(userid) == 2 and isAlive(userid):
        if not lastRequest:
            lrMenu.unsend(userid)
            lrMenu.send(userid)
        else:
            tell(userid, 'Mooore? I deny thee!')
    else:
        tell(userid, 'You cannot use the !lr command!')
        
def cmd_gt(userid, args):
    pop = popuplib.find('gt_ranks_top10')
    if pop:
        pop.send(userid)
        
    else:
        gtUpdatePop()
        popuplib.find('gt_ranks_top10').send(userid)
        
def lrSelect(userid, choice, popupname):
    livingCT(choice, callback=CTSelect).send(userid)
    
def isAlive(userid):
    a = playerlib.getPlayer(userid).isdead
    if a: return False
    return True
    
def confirmMenu(t, ct, game, callback):
    if popuplib.exists('lr_confirm'): popuplib.delete('lr_confirm')
    p = popuplib.easymenu('lr_confirm', None, callback)
    p.settitle('Play %s?'%game)
    p.addoption((True, t, ct, game), 'Yes!')
    p.addoption((False, t, ct, game), 'No!')
    return p
    
def reqDead():
    for i in mustDie:
        if isALive(i): return False
    return True
    
def confirmation(userid, choice, popupname):
    global lastRequest
    acc, t, ct, game = choice
    if acc:
        lastRequest = lr(t, ct)
        lastRequest._start()
        stripGive((t, ct), ())
        msg('%s and %s are playing a game!'%(es.getplayername(t), es.getplayername(ct)))
    else:
        mustDie.append(ct)
        msg('%s denied playing a game with %s!'%(es.getplayername(ct), es.getplayername(t)))
    
    
def CTSelect(userid, choice, args):
    global lastRequest
    if canLR and isAlive(userid):
        ct, game = choice
        if reqDead():
            if game == 'Other':
                confirmMenu(userid, ct, game, confirmation).send(ct)
                
            elif game == 'Race':
                lastRequest = lr(userid, ct)
                lastRequest._start()
                msg('%s and %s are Racing!'%(es.getplayername(userid), es.getplayername(ct)))
                
            elif game == 'BasketBall':
                lastRequest = lr(userid, ct)
                lastRequest._start()
                stripGive((userid, ct), 'weapon_deagle')
                for i in (userid, ct):
                    es.delayed(0.1, 'playerset ammo %s weapon_deagle 0'%i)
                    es.delayed(0.1, 'playerset clip %s weapon_deagle 0'%i)
                msg('%s and %s are playing BasketBall!'%(es.getplayername(userid), es.getplayername(ct)))
                
            elif game == 'Gun Toss':
                lastRequest = lr(userid, ct)
                lastRequest._start()
                gamethread.delayed(0.5, lastRequest.startTrace)
                stripGive((userid, ct), 'weapon_deagle')
                for i in (userid, ct):
                    es.delayed(0.1, 'playerset ammo %s weapon_deagle 0'%i)
                    es.delayed(0.1, 'playerset clip %s weapon_deagle 0'%i)
                # Need to add "tracking"
                msg('%s and %s are having a Gun Toss'%(es.getplayername(userid), es.getplayername(ct)))
                
            elif game == 'Shot for Shot':
                lastRequest = lr(userid, ct)
                lastRequest._start()
                lastRequest.starthud()
                stripGive((userid, ct), 'weapon_deagle')
                msg('%s and %s are playing Shot for Shot'%(es.getplayername(userid), es.getplayername(ct)))
                
            elif game == 'Knife Fight':
                lastRequest = lr(userid, ct)
                lastRequest._start()
                stripGive((userid, ct), ())
                msg('%s and %s are having a Knife Fight'%(es.getplayername(userid), es.getplayername(ct)))
                
            elif game == 'Spray Contest':
                lastRequest = lr(userid, ct)
                lastRequest._start()
                stripGive((userid, ct), ())
                msg('%s and %s are having a spray contest'%(es.getplayername(userid), es.getplayername(ct)))
                
            elif game == 'Water Bottle Baseball':
                lastRequest = lr(userid, ct)
                lastRequest._start()
                stripGive((userid, ct), ('weapon_deagle', 'info_null'))
                msg('%s and %s are playing Water Bottle Baseball'%(es.getplayername(userid), es.getplayername(ct)))
                
            elif game == 'Chicken Fight':
                lastRequest = lr(userid, ct)
                lastRequest._start()
                stripGive((userid, ct), ())
                msg('%s and %s are having a Chicken Fight'%(es.getplayername(userid), es.getplayername(ct)))
                
            else:
                #weaponList(ct, game, callback=weaponSelect).send(userid)
                msg('Crit. Error! Game Not Found! (%s)'%game)
        else:
            tell(userid, 'You must first hunt those who have refused you!')
    else:
        tell(userid, 'The time for last requests has passed!')
        
def stripGive(users, weapons, knife=True, index=False):
    if isinstance(users, str):
        users = (users,)
    if isinstance(weapons, str):
        weapons = (weapons,)
    
    es.server.queuecmd('es_xfire %s player_weaponstrip kill'%users[0])
    for userid in users:
        es.server.queuecmd('es_xgive %s player_weaponstrip'%userid)
        es.server.queuecmd('es_xfire %s player_weaponstrip strip'%userid)
        for weapon in weapons:
            es.delayed(0.1, 'es_xgive %s %s'%(userid, weapon))
            if index:
                es.delayed(0.1, 'es lr_index %s %s server_var(eventscripts_lastgive)'%(userid, weapon))
        if knife:
            es.delayed(0.1, 'es_xgive %s weapon_knife'%userid)

def weaponSelect(userid, choice, popupname):
    global lastRequest
    if canLR and isAlive(userid):
        ct, game, weapon = choice
        if reqDead():
            msg('Crit. Error! Game Not Found! (%s)'%game)
        else:
            tell(userid, 'You must first hunt those who have refused you!')
    else:
        tell(userid, 'The time for last requests has passed!')
        
        
gtRanks = [] # [ [steamid, distance, name], [steamid, distance, name], ... ]
        
def gtLoad():
    # Load guntoss ranks
    loc = str(es.ServerVar('eventscripts_addondir')) + '/lr/gunTossRanks.db'
    global gtRanks
    if os.path.isfile(loc):
        gtfile = open(loc, 'rb')
        gtRanks = cPickle.load(gtfile)
        gtfile.close()
    else:
        gtRanks = []
        
    gtUpdatePop()
    
def gtSave():
    if gtRanks:
        loc = str(es.ServerVar('eventscripts_addondir')) + '/lr/gunTossRanks.db'
        gtfile = open(loc, 'wb')
        cPickle.dump(gtRanks, gtfile, cPickle.HIGHEST_PROTOCOL)
        gtfile.close()
    
def gtSubmit(steamid, distance, name):
    
    steamids = map(lambda x: x[0], gtRanks)
    
    if steamid in steamids:
        index = steamids.index(steamid)
        if distance > gtRanks[index][1]:
            gtRanks.pop(index)
            gtRanks.append([steamid, distance, name])
            gtRanks.sort(key=lambda x: x[1], reverse=True)
            return True
        return False

    l = len(gtRanks)
    
    if l == 10:
        if distance > gtRanks[9][1]:
            gtRanks.pop(9)
            gtRanks.append([steamid, distance, name])
            gtRanks.sort(key=lambda x: x[1], reverse=True)
            return True
            
    else:
        gtRanks.append([steamid, distance, name])
        gtRanks.sort(key=lambda x: x[1], reverse=True)
        return True
    
    return False
        
def gtUpdatePop():
    if popuplib.exists('gt_ranks_top10'): popuplib.delete('gt_ranks_top10')
    
    p = popuplib.create('gt_ranks_top10')
    p.addline('GunToss - Top Tosses')
    p.addline('--------------------')
    for i in range(len(gtRanks)):
        steamid, distance, name = gtRanks[i]
        p.addline('->%s - %s : %.1f'%(i+1, name, float(distance)))
    p.addline('0 - Exit')
    p.timeout = 30
    
    
        
lrMenu = popuplib.easymenu('lr_mainmenu', None, lrSelect)
lrMenu.settitle('Last Request')
for game in games:
    lrMenu.addoption(game, game)